aboutsummaryrefslogtreecommitdiff
path: root/source
diff options
context:
space:
mode:
authorEinhard Leichtfuß <alguien@respiranto.de>2019-10-18 00:28:00 +0200
committerEinhard Leichtfuß <alguien@respiranto.de>2019-10-18 01:17:39 +0200
commit4e2ceb9875c81c33b09f6eaf0858b7f9591b22cc (patch)
treebe3860dc8c26b3c18a30c2a81b58e00025b98069 /source
parent51f58d7c4c984ec8ccc5ab0a3d31d04cd39d499c (diff)
downloadrsync-backup-4e2ceb9875c81c33b09f6eaf0858b7f9591b22cc.tar.gz
rsync-backup-4e2ceb9875c81c33b09f6eaf0858b7f9591b22cc.tar.xz
Restructure, and rewrite substantial partsHEADmasterdevel
A notable problem (to me) with the former version was, that upon simple movements in the source file tree, these would in general cause duplicated data in the backup forest. This problem has been resolved by essentially tracking file movements, using hard links. Also, the code has been divided into several different files, extranous code removed, the organization of remote code execution simplified. In the process of simplification, all parts requiring direct interaction of the user with the program have been replaced. In most cases, this means that the program now just terminates with an error instead of allowing the user to confirm deletion of an unexpected (remnant) file. This may be considered a drawback, but actually these interactive options were anyways suboptimal solutions in most cases - where they occured, which was due to remnant files of aborted or failed former backups. In general, there have been a lot of changes. Which are not thoroughly documented here. Since there is often no strong relation to the old code, this is not deemed necessary, as the in-code documentation is expected to be of sufficient help. Also, there has been added a little general documentation in the README and particularly the NOTES file. It is to be noted that this new version is far from sophisticated. It has been tested with and is in use for real data, however lacks a lot of convenience. In particular, if a backup fails unexpectedly, the next backup will in the very most cases loudly fail without manual intervention. Also, the program is not able to continue the growth of a backup tree built with former versions of this program, by itself. This can however be arranged by hand.
Diffstat (limited to 'source')
-rw-r--r--source69
1 files changed, 69 insertions, 0 deletions
diff --git a/source b/source
new file mode 100644
index 0000000..5bbdac6
--- /dev/null
+++ b/source
@@ -0,0 +1,69 @@
+#!/usr/bin/env bash
+#
+# source - functions acting on the source host.
+#
+# Copyright 2015 - 2019 Einhard Leichtfuß
+#
+# This file is part of rsync-backup.
+#
+# rsync-backup is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published
+# by the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# rsync-backup is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public License
+# along with rsync-backup. If not, see <https://www.gnu.org/licenses/>.
+#
+
+
+# Set up a new local mirror file tree on the source.
+#
+# requires: assert_is_dir, create_dir, replace_symlink,
+# $src_path, $src_mirror_reldir,
+# $RSYNC, ${rsync_args[@]}, ${filter_args[@]},
+# $DATEFMT,
+#
+function src_prepare
+{
+ local mirrors_dir="${src_path}/${src_mirror_reldir}"
+ local old_mirror="${mirrors_dir}/old"
+ local new_mirror="${mirrors_dir}/new"
+ local tmp_mirror="${mirrors_dir}/tmp"
+ local bakdate
+
+ assert_is_dir "$src_path" || return $?
+
+ message 'Create mirror of the source tree...'
+
+ if [[ ! -d "$mirrors_dir" ]]
+ then
+ create_dir "$mirrors_dir" || return $?
+ create_dir "$tmp_mirror" || return $?
+ ln -s 'none' "$old_mirror" || return $RET_ERROR
+ else
+ replace_symlink "$new_mirror" "$old_mirror" || return $?
+ create_dir "$tmp_mirror" || return $?
+ fi
+
+ "$RSYNC" \
+ --exclude="/${src_mirror_reldir}/***" \
+ "${rsync_args[@]}" \
+ "${filter_args[@]}" \
+ --link-dest="$src_path" \
+ "${src_path}/" "$tmp_mirror" || return $RET_ERROR
+
+ bakdate=`date +"$DATEFMT"`
+ mv "$tmp_mirror" "${mirrors_dir}/${bakdate}" || return $RET_ERROR
+ ln -s "$bakdate" "$new_mirror" || return $RET_ERROR
+
+ message 'Finished creating mirror of the source tree.'
+
+ return $RET_SUCCESS
+}
+
+# vi: ft=bash ts=2 sw=2 noet